diff --git a/scite/src/Extender.h b/scite/src/Extender.h
index 8b04be8..43866d3 100644
--- a/scite/src/Extender.h
+++ b/scite/src/Extender.h
@@ -66,7 +66,7 @@ public:
 	}
 	virtual bool OnDoubleClick() { return false; }
 	virtual bool OnUpdateUI() { return false; }
-	virtual bool OnMarginClick() { return false; }
+	virtual bool OnMarginClick(int, int) { return false; } // fincs-edit
 	virtual bool OnMacro(const char *, const char *) { return false; }
 	virtual bool OnUserListSelection(int, const char *) { return false; }
 
diff --git a/scite/src/IFaceTable.cxx b/scite/src/IFaceTable.cxx
index 186c49f..4af9535 100644
--- a/scite/src/IFaceTable.cxx
+++ b/scite/src/IFaceTable.cxx
@@ -411,6 +411,47 @@ static IFaceConstant ifaceConstants[] = {
 	{"SCE_ADA_STRING",7},
 	{"SCE_ADA_STRINGEOL",8},
 	{"SCE_ADA_WORD",1},
+	{"SCE_AHK_COMMENTBLOCK",2},
+	{"SCE_AHK_COMMENTLINE",1},
+	{"SCE_AHK_DEFAULT",0},
+	{"SCE_AHK_ERROR",20},
+	{"SCE_AHK_ESCAPE",3},
+	{"SCE_AHK_EXPOPERATOR",5},
+	{"SCE_AHK_IDENTIFIER",8},
+	{"SCE_AHK_LABEL",10},
+	{"SCE_AHK_NUMBER",7},
+	{"SCE_AHK_STRING",6},
+	{"SCE_AHK_SYNOPERATOR",4},
+	{"SCE_AHK_VARREF",9},
+	{"SCE_AHK_VARREFKW",19},
+	{"SCE_AHK_WORD_CF",11},
+	{"SCE_AHK_WORD_CMD",12},
+	{"SCE_AHK_WORD_DIR",14},
+	{"SCE_AHK_WORD_FN",13},
+	{"SCE_AHK_WORD_KB",15},
+	{"SCE_AHK_WORD_SP",17},
+	{"SCE_AHK_WORD_UD",18},
+	{"SCE_AHK_WORD_VAR",16},
+	{"SCE_AHK2_BIF",14},
+	{"SCE_AHK2_BIV",13},
+	{"SCE_AHK2_COMMENTBLOCK",2},
+	{"SCE_AHK2_COMMENTLINE",1},
+	{"SCE_AHK2_DEFAULT",0},
+	{"SCE_AHK2_DIRECTIVE",10},
+	{"SCE_AHK2_ERROR",15},
+	{"SCE_AHK2_ESCAPE",3},
+	{"SCE_AHK2_FLOW",12},
+	{"SCE_AHK2_FUNC",9},
+	{"SCE_AHK2_LABEL",11},
+	{"SCE_AHK2_NUMBER",6},
+	{"SCE_AHK2_OBJMETHOD",17},
+	{"SCE_AHK2_OBJMETHOD_BI",19},
+	{"SCE_AHK2_OBJPROP",16},
+	{"SCE_AHK2_OBJPROP_BI",18},
+	{"SCE_AHK2_OPERATOR",4},
+	{"SCE_AHK2_STRING",5},
+	{"SCE_AHK2_VAR",8},
+	{"SCE_AHK2_WORDOP",7},
 	{"SCE_APDL_ARGUMENT",11},
 	{"SCE_APDL_COMMAND",8},
 	{"SCE_APDL_COMMENT",1},
@@ -2387,6 +2428,8 @@ static IFaceConstant ifaceConstants[] = {
 	{"SCLEX_A68K",100},
 	{"SCLEX_ABAQUS",84},
 	{"SCLEX_ADA",20},
+	{"SCLEX_AHK1",200},
+	{"SCLEX_AHK2",201},
 	{"SCLEX_APDL",61},
 	{"SCLEX_AS",113},
 	{"SCLEX_ASM",34},
@@ -3260,7 +3303,7 @@ static IFaceProperty ifaceProperties[] = {
 
 enum {
 	ifaceFunctionCount = 293,
-	ifaceConstantCount = 2601,
+	ifaceConstantCount = sizeof(ifaceConstants) / sizeof(IFaceConstant),
 	ifacePropertyCount = 221
 };
 
diff --git a/scite/src/LuaExtension.cxx b/scite/src/LuaExtension.cxx
index 1c9a280..bda057b 100644
--- a/scite/src/LuaExtension.cxx
+++ b/scite/src/LuaExtension.cxx
@@ -1329,6 +1329,11 @@ static bool InitGlobalScope(bool checkProperties, bool forceReload = false) {
 	// ...register standard libraries
 	luaL_openlibs(luaState);
 
+#ifdef WIN32
+	extern int MessagePumpLibInit(lua_State* L);
+	MessagePumpLibInit(luaState);
+#endif
+
 	lua_register(luaState, "_ALERT", cf_global_print);
 
 	// although this is mostly redundant with output:append
@@ -2034,8 +2039,8 @@ bool LuaExtension::OnUpdateUI() {
 	return CallNamedFunction("OnUpdateUI");
 }
 
-bool LuaExtension::OnMarginClick() {
-	return CallNamedFunction("OnMarginClick");
+bool LuaExtension::OnMarginClick(int position, int margin) { // fincs-edit
+	return CallNamedFunction("OnMarginClick", position, margin); // fincs-edit
 }
 
 bool LuaExtension::OnUserListSelection(int listType, const char *selection) {
diff --git a/scite/src/LuaExtension.h b/scite/src/LuaExtension.h
index b4acf12..c303f72 100644
--- a/scite/src/LuaExtension.h
+++ b/scite/src/LuaExtension.h
@@ -34,7 +34,7 @@ public:
 	virtual bool OnStyle(unsigned int startPos, int lengthDoc, int initStyle, StyleWriter *styler);
 	virtual bool OnDoubleClick();
 	virtual bool OnUpdateUI();
-	virtual bool OnMarginClick();
+	virtual bool OnMarginClick(int position, int margin); // fincs-edit
 	virtual bool OnUserListSelection(int listType, const char *selection);
 	virtual bool OnKey(int keyval, int modifiers);
 	virtual bool OnDwellStart(int pos, const char *word);
diff --git a/scite/src/MultiplexExtension.cxx b/scite/src/MultiplexExtension.cxx
index fc44aa3..65f40e2 100644
--- a/scite/src/MultiplexExtension.cxx
+++ b/scite/src/MultiplexExtension.cxx
@@ -197,10 +197,10 @@ bool MultiplexExtension::OnUpdateUI() {
 	return handled;
 }
 
-bool MultiplexExtension::OnMarginClick() {
+bool MultiplexExtension::OnMarginClick(int p, int q) { // fincs-edit
 	bool handled = false;
 	for (int i = 0; i < extensionCount && !handled; ++i)
-		if (extensions[i]->OnMarginClick())
+		if (extensions[i]->OnMarginClick(p, q)) // fincs-edit
 			handled = true;
 	return handled;
 }
diff --git a/scite/src/MultiplexExtension.h b/scite/src/MultiplexExtension.h
index 661e5af..03e948f 100644
--- a/scite/src/MultiplexExtension.h
+++ b/scite/src/MultiplexExtension.h
@@ -64,7 +64,7 @@ public:
 	virtual bool OnStyle(unsigned int, int, int, StyleWriter *);
 	virtual bool OnDoubleClick();
 	virtual bool OnUpdateUI();
-	virtual bool OnMarginClick();
+	virtual bool OnMarginClick(int, int); // fincs-edit
 	virtual bool OnMacro(const char *, const char *);
 	virtual bool OnUserListSelection(int, const char *);
 
diff --git a/scite/src/SciTE.h b/scite/src/SciTE.h
index 5b969be..ed0c507 100644
--- a/scite/src/SciTE.h
+++ b/scite/src/SciTE.h
@@ -9,10 +9,12 @@
 #define SCITE_H
 
 // Version numbers and dates
-#define VERSION_SCITE "3.6.0"
-#define VERSION_WORDS 3, 6, 0, 0
+#define VERSION_SCITE "3.0.07"
+#define VERSION_ORGSCITE "3.6.0"
+#define VERSION_WORDS 3, 0, 7, 0
 #define COPYRIGHT_DATES "December 1998-August 2015"
 #define COPYRIGHT_YEARS "1998-2015"
+#define COPYRIGHT_YEARS_S4AHK "2007-2015"
 
 // Menu IDs.
 // These are located 100 apart. No one will want more than 100 in each menu ;)
@@ -272,6 +274,8 @@
 #define IDBM_BACKSLASH 104
 #define IDBM_AROUND 105
 #define IDBM_UP 106
+#define IDR_CLOSEFILE_BIG 107
+#define IDI_MAINICON 500
 
 #define IDBM_20_WORD 201
 #define IDBM_20_CASE 202
diff --git a/scite/src/SciTEBase.cxx b/scite/src/SciTEBase.cxx
index 52af55b..7a94169 100644
--- a/scite/src/SciTEBase.cxx
+++ b/scite/src/SciTEBase.cxx
@@ -14,6 +14,9 @@
 #include <stdarg.h>
 #include <sys/stat.h>
 #include <time.h>
+#ifdef WIN32
+#include <windows.h> // for MulDiv()
+#endif
 
 #include <string>
 #include <vector>
@@ -147,6 +150,7 @@ SciTEBase::SciTEBase(Extension *ext) : apis(true), extender(ext) {
 	bracesCheck = true;
 	bracesSloppy = false;
 	bracesStyle = 0;
+	bracesStyle2 = 0;
 	braceCount = 0;
 
 	indentationWSVisible = true;
@@ -155,6 +159,7 @@ SciTEBase::SciTEBase(Extension *ext) : apis(true), extender(ext) {
 	imeAutoComplete = false;
 	callTipUseEscapes = false;
 	callTipIgnoreCase = false;
+	callTipSkipBareWords = false;
 	autoCCausedByOnlyOne = false;
 	startCalltipWord = 0;
 	currentCallTip = 0;
@@ -184,6 +189,7 @@ SciTEBase::SciTEBase(Extension *ext) : apis(true), extender(ext) {
 
 	needReadProperties = false;
 	quitting = false;
+	debugging = false;
 
 	timerMask = 0;
 	delayBeforeAutoSave = 0;
@@ -477,6 +483,7 @@ bool SciTEBase::FindMatchingBracePosition(bool editor, int &braceAtCaret, int &b
 		return false;
 
 	int bracesStyleCheck = editor ? bracesStyle : 0;
+	int bracesStyleCheck2 = editor ? bracesStyle2 : 0;
 	int caretPos = win.Call(SCI_GETCURRENTPOS, 0, 0);
 	braceAtCaret = -1;
 	braceOpposite = -1;
@@ -493,7 +500,7 @@ bool SciTEBase::FindMatchingBracePosition(bool editor, int &braceAtCaret, int &b
 	}
 	// Priority goes to character before caret
 	if (charBefore && IsBrace(charBefore) &&
-	        ((styleBefore == bracesStyleCheck) || (!bracesStyle))) {
+	        (((styleBefore == bracesStyleCheck) || (!bracesStyle)) || ((styleBefore == bracesStyleCheck2) || (!bracesStyle2)))) {
 		braceAtCaret = caretPos - 1;
 	}
 	bool colonMode = false;
@@ -509,7 +516,7 @@ bool SciTEBase::FindMatchingBracePosition(bool editor, int &braceAtCaret, int &b
 		if (win.Send(SCI_POSITIONAFTER, caretPos) == (caretPos + 1)) {
 			char charAfter = acc[caretPos];
 			int styleAfter = acc.StyleAt(caretPos);
-			if (charAfter && IsBrace(charAfter) && ((styleAfter == bracesStyleCheck) || (!bracesStyle))) {
+			if (charAfter && IsBrace(charAfter) && (((styleAfter == bracesStyleCheck) || (!bracesStyle)) || ((styleAfter == bracesStyleCheck2) || (!bracesStyle2)))) {
 				braceAtCaret = caretPos;
 				isAfter = false;
 			}
@@ -611,6 +618,9 @@ void SciTEBase::SetWindowName() {
 		windowName += GUI_TEXT("]");
 	}
 
+	if (debugging)
+		windowName += GUI_TEXT(" [Debugging]");
+
 	wSciTE.SetTitle(windowName.c_str());
 }
 
@@ -964,6 +974,11 @@ void SciTEBase::MarkAll(MarkPurpose purpose) {
 	SetIdler(true);
 }
 
+void SciTEBase::ClearAllBookmarks() {
+	wEditor.Call(SCI_MARKERDELETEALL, markerBookmark);
+	RemoveFindMarks();
+}
+
 int SciTEBase::IncrementSearchMode() {
 	FindIncrement();
 	return 0;
@@ -1380,10 +1395,18 @@ void SciTEBase::ToggleOutputVisible() {
 		WindowSetFocus(wEditor);
 	} else {
 		if (previousHeightOutput < 20) {
+#ifndef WIN32
 			if (splitVertical)
 				heightOutput = NormaliseSplit(300);
 			else
 				heightOutput = NormaliseSplit(100);
+#else
+			extern int g_ScreenDPI;
+			if (splitVertical)
+				heightOutput = NormaliseSplit(MulDiv(300, g_ScreenDPI, 96));
+			else
+				heightOutput = NormaliseSplit(MulDiv(100, g_ScreenDPI, 96));
+#endif
 			previousHeightOutput = heightOutput;
 		} else {
 			heightOutput = NormaliseSplit(previousHeightOutput);
@@ -1461,13 +1484,10 @@ void SciTEBase::Redraw() {
 }
 
 std::string SciTEBase::GetNearestWords(const char *wordStart, size_t searchLen,
-		const char *separators, bool ignoreCase /*=false*/, bool exactLen /*=false*/) {
-	std::string words;
-	while (words.empty() && *separators) {
-		words = apis.GetNearestWords(wordStart, searchLen, ignoreCase, *separators, exactLen);
-		separators++;
-	}
-	return words;
+		const char *separators, bool ignoreCase /*=false*/, bool exactLen /*=false*/,
+		bool separatorIsRequired /*=false*/) {
+	return apis.GetNearestWords(wordStart, searchLen, ignoreCase, separators, exactLen,
+			separatorIsRequired);
 }
 
 void SciTEBase::FillFunctionDefinition(int pos /*= -1*/) {
@@ -1476,7 +1496,7 @@ void SciTEBase::FillFunctionDefinition(int pos /*= -1*/) {
 	}
 	if (apis) {
 		std::string words = GetNearestWords(currentCallTipWord.c_str(), currentCallTipWord.length(),
-			calltipParametersStart.c_str(), callTipIgnoreCase, true);
+			calltipParametersStart.c_str(), callTipIgnoreCase, true, callTipSkipBareWords);
 		if (words.empty())
 			return;
 		// Counts how many call tips
@@ -1484,7 +1504,7 @@ void SciTEBase::FillFunctionDefinition(int pos /*= -1*/) {
 
 		// Should get current api definition
 		std::string word = apis.GetNearestWord(currentCallTipWord.c_str(), currentCallTipWord.length(),
-		        callTipIgnoreCase, calltipWordCharacters, currentCallTip);
+		        callTipIgnoreCase, calltipWordCharacters, currentCallTip, callTipSkipBareWords);
 		if (word.length()) {
 			functionDefinition = word;
 			if (maxCallTips > 1) {
@@ -1554,6 +1574,8 @@ bool SciTEBase::StartCallTip() {
 	while (startCalltipWord > 0 &&
 	        Contains(calltipWordCharacters, line[startCalltipWord - 1])) {
 		startCalltipWord--;
+		if (line[startCalltipWord] == '.' && (lexLanguage == SCLEX_AHK1 || lexLanguage == SCLEX_AHK2))
+			break;
 	}
 
 	line.at(current) = '\0';
@@ -1588,7 +1610,7 @@ void SciTEBase::ContinueCallTip() {
 			commas--;
 		// If it reached the end of the argument list it means that the user typed in more
 		// arguments than the ones listed in the calltip
-		if (Contains(calltipParametersEnd, functionDefinition[startHighlight]))
+		if (functionDefinition[startHighlight] && Contains(calltipParametersEnd, functionDefinition[startHighlight]))
 			commas = 0;
 		else
 			startHighlight++;
@@ -1654,12 +1676,15 @@ bool SciTEBase::StartAutoComplete() {
 	        (Contains(calltipWordCharacters, line[startword - 1]) ||
 		Contains(autoCompleteStartCharacters, line[startword - 1]))) {
 		startword--;
+		if (line[startword] == '.' && (lexLanguage == SCLEX_AHK1 || lexLanguage == SCLEX_AHK2))
+			break;
 	}
 
 	std::string root = line.substr(startword, current - startword);
 	if (apis) {
 		std::string words = GetNearestWords(root.c_str(), root.length(),
-			calltipParametersStart.c_str(), autoCompleteIgnoreCase);
+			calltipParametersStart.c_str(), autoCompleteIgnoreCase,
+			false, false);
 		if (words.length()) {
 			EliminateDuplicateWords(words);
 			wEditor.Call(SCI_AUTOCSETSEPARATOR, ' ');
@@ -3970,7 +3995,7 @@ void SciTEBase::Notify(const SCNotification *notification) {
 
 	case SCN_MARGINCLICK: {
 			if (extender)
-				handled = extender->OnMarginClick();
+				handled = extender->OnMarginClick(notification->position, notification->margin); // fincs-edit
 			if (!handled) {
 				if (notification->margin == 2) {
 					MarginClick(notification->position, notification->modifiers);
diff --git a/scite/src/SciTEBase.h b/scite/src/SciTEBase.h
index 38c385a..5d88dd8 100644
--- a/scite/src/SciTEBase.h
+++ b/scite/src/SciTEBase.h
@@ -311,6 +311,7 @@ public:
 	virtual void HideMatch() = 0;
 	enum MarkPurpose { markWithBookMarks, markIncremental };
 	virtual void MarkAll(MarkPurpose purpose=markWithBookMarks) = 0;
+	virtual void ClearAllBookmarks() = 0;
 	virtual int ReplaceAll(bool inSelection) = 0;
 	virtual void ReplaceOnce(bool showWarnings=true) = 0;
 	virtual void UIClosed() = 0;
@@ -432,6 +433,7 @@ protected:
 	Extension *extender;
 	bool needReadProperties;
 	bool quitting;
+	bool debugging;
 
 	int timerMask;
 	enum { timerAutoSave=1 };
@@ -447,7 +449,7 @@ protected:
 	bool bufferedDraw;
 	bool bracesCheck;
 	bool bracesSloppy;
-	int bracesStyle;
+	int bracesStyle, bracesStyle2;
 	int braceCount;
 
 	bool indentationWSVisible;
@@ -462,6 +464,7 @@ protected:
 	std::string calltipParametersEnd;
 	std::string calltipParametersSeparators;
 	std::string calltipEndDefinition;
+	bool callTipSkipBareWords;
 	std::string autoCompleteStartCharacters;
 	std::string autoCompleteFillUpCharacters;
 	std::string wordCharacters;
@@ -742,7 +745,8 @@ protected:
 	void GoMessage(int dir);
 	virtual bool StartCallTip();
 	std::string GetNearestWords(const char *wordStart, size_t searchLen,
-		const char *separators, bool ignoreCase=false, bool exactLen=false);
+		const char *separators, bool ignoreCase=false, bool exactLen=false,
+		bool separatorIsRequired=false);
 	virtual void FillFunctionDefinition(int pos = -1);
 	void ContinueCallTip();
 	virtual void EliminateDuplicateWords(std::string &words);
@@ -805,6 +809,7 @@ protected:
 
 	void RemoveFindMarks();
 	void MarkAll(MarkPurpose purpose=markWithBookMarks);
+	void ClearAllBookmarks();
 	void BookmarkAdd(int lineno = -1);
 	void BookmarkDelete(int lineno = -1);
 	bool BookmarkPresent(int lineno = -1);
diff --git a/scite/src/SciTEIO.cxx b/scite/src/SciTEIO.cxx
index d1dfe8c..517d8b5 100644
--- a/scite/src/SciTEIO.cxx
+++ b/scite/src/SciTEIO.cxx
@@ -588,6 +588,19 @@ bool SciTEBase::Open(FilePath file, OpenFlags of) {
 			wEditor.Call(SCI_EMPTYUNDOBUFFER);
 		}
 		CurrentBuffer()->isReadOnly = props.GetInt("read.only");
+		extern bool _IsProtectedFile(FilePath);
+		if (_IsProtectedFile(filePath))
+		{
+			GUI::gui_string msg = LocaliseMessage(
+				"File '^0' is an internal SciTE4AutoHotkey program file.\n\n"
+				"It is strongly advised not to edit this file. Future SciTE4AutoHotkey updates will overwrite your changes.\n"
+				"In order to change a setting configured here, copy it to your personal settings file "
+				"(Tools > Open User properties) and change it.\n"
+				"If you rather want to delete a setting, add a line to the User properties that sets it to blank."
+				, filePath.AsInternal());
+			WindowMessageBox(wSciTE, msg);
+			CurrentBuffer()->isReadOnly = true;
+		}
 		wEditor.Call(SCI_SETREADONLY, CurrentBuffer()->isReadOnly);
 	}
 	RemoveFileFromStack(filePath);
diff --git a/scite/src/SciTEProps.cxx b/scite/src/SciTEProps.cxx
index 3457205..898a25e 100644
--- a/scite/src/SciTEProps.cxx
+++ b/scite/src/SciTEProps.cxx
@@ -13,6 +13,9 @@
 #include <fcntl.h>
 #include <time.h>
 #include <locale.h>
+#ifdef WIN32
+#include <windows.h> // for MulDiv()
+#endif
 
 #include <string>
 #include <vector>
@@ -887,6 +890,8 @@ void SciTEBase::ReadProperties() {
 	char bracesStyleKey[200];
 	sprintf(bracesStyleKey, "braces.%s.style", language.c_str());
 	bracesStyle = props.GetInt(bracesStyleKey, 0);
+	strcat(bracesStyleKey, "2");
+	bracesStyle2 = props.GetInt(bracesStyleKey, 0);
 
 	char key[200];
 	std::string sval;
@@ -904,6 +909,9 @@ void SciTEBase::ReadProperties() {
 
 	calltipEndDefinition = FindLanguageProperty("calltip.*.end.definition");
 
+	sval = FindLanguageProperty("calltip.*.skip.bare.words");
+	callTipSkipBareWords = sval == "1";
+
 	sprintf(key, "autocomplete.%s.start.characters", language.c_str());
 	autoCompleteStartCharacters = props.GetExpandedString(key);
 	if (autoCompleteStartCharacters == "")
@@ -1395,6 +1403,10 @@ void SciTEBase::SetPropertiesInitial() {
 	lineNumbers = props.GetInt("line.margin.visible");
 	margin = props.GetInt("margin.width");
 	foldMargin = props.GetInt("fold.margin.width", foldMarginWidthDefault);
+#ifdef WIN32
+	extern int g_ScreenDPI;
+	foldMarginWidth = MulDiv(foldMarginWidth, g_ScreenDPI, 96);
+#endif
 
 	matchCase = props.GetInt("find.replace.matchcase");
 	regExp = props.GetInt("find.replace.regexp");
@@ -1479,7 +1491,12 @@ void SciTEBase::ReadPropertiesInitial() {
 		(splitVertical && (sizeHorizontal > 0) && (heightOutput < sizeHorizontal))) {
 		previousHeightOutput = splitVertical ? sizeHorizontal : sizeVertical;
 		if (!hideOutput) {
+#ifndef WIN32
 			heightOutput = NormaliseSplit(previousHeightOutput);
+#else
+			extern int g_ScreenDPI;
+			heightOutput = NormaliseSplit(MulDiv(previousHeightOutput, g_ScreenDPI, 96));
+#endif
 			SizeSubWindows();
 			Redraw();
 		}
diff --git a/scite/src/StringList.cxx b/scite/src/StringList.cxx
index 20c6327..11bac6e 100644
--- a/scite/src/StringList.cxx
+++ b/scite/src/StringList.cxx
@@ -156,13 +156,19 @@ struct CompareStringInsensitive {
 };
 
 template<typename Compare>
-	std::string GetMatch(std::vector<char *>::iterator start, std::vector<char *>::iterator end, const char *wordStart, const std::string &wordCharacters, int wordIndex, Compare comp) {
+	std::string GetMatch(std::vector<char *>::iterator start, std::vector<char *>::iterator end, const char *wordStart, const std::string &wordCharacters, int wordIndex, Compare comp, bool skipBareWords = false) {
 	std::vector<char *>::iterator elem = std::lower_bound(start, end, wordStart, comp);
 	if (!comp(wordStart, *elem) && !comp(*elem, wordStart)) {
 		// Found a matching element, now move forward wordIndex matching elements
 		for (; elem < end; ++elem) {
 			const char *word = *elem;
 			if (!word[comp.searchLen] || !Contains(wordCharacters, word[comp.searchLen])) {
+				if (skipBareWords) {
+					unsigned int i;
+					for (i = comp.searchLen; (i < strlen(word)) && IsASpace(word[i]); i++);
+						if (!word[i])
+							continue;
+				}
 				if (wordIndex <= 0) {
 					return std::string(word);
 				}
@@ -181,32 +187,40 @@ template<typename Compare>
  * The length of the word to compare is passed too.
  * Letter case can be ignored or preserved.
  */
-std::string StringList::GetNearestWord(const char *wordStart, size_t searchLen, bool ignoreCase, const std::string &wordCharacters, int wordIndex) {
+std::string StringList::GetNearestWord(const char *wordStart, size_t searchLen, bool ignoreCase, const std::string &wordCharacters, int wordIndex, bool skipBareWords /*= false*/) {
 	if (words.empty())
 		return std::string();
 	SortIfNeeded(ignoreCase);
 	if (ignoreCase) {
-		return GetMatch(wordsNoCase.begin(), wordsNoCase.end(), wordStart, wordCharacters, wordIndex, CompareStringInsensitive(searchLen));
+		return GetMatch(wordsNoCase.begin(), wordsNoCase.end(), wordStart, wordCharacters, wordIndex, CompareStringInsensitive(searchLen), skipBareWords);
 	} else { // preserve the letter case
-		return GetMatch(words.begin(), words.end(), wordStart, wordCharacters, wordIndex, CompareString(searchLen));
+		return GetMatch(words.begin(), words.end(), wordStart, wordCharacters, wordIndex, CompareString(searchLen), skipBareWords);
 	}
 }
 
+static const char* strchrany(const char* str, const char* delim)
+{
+	for (; *str; str++)
+		if (strchr(delim, *str))
+			return str;
+	return NULL;
+}
+
 /**
  * Find the length of a 'word' which is actually an identifier in a string
  * which looks like "identifier(..." or "identifier" and where
  * there may be extra spaces after the identifier that should not be
  * counted in the length.
  */
-static size_t LengthWord(const char *word, char otherSeparator) {
+static size_t LengthWord(const char *word, const char* otherSeparators, bool separatorIsRequired=false) {
 	const char *endWord = 0;
 	// Find an otherSeparator
-	if (otherSeparator)
-		endWord = strchr(word, otherSeparator);
+	if (otherSeparators)
+		endWord = strchrany(word, otherSeparators);
 	// Find a '('. If that fails go to the end of the string.
 	if (!endWord)
 		endWord = strchr(word, '(');
-	if (!endWord)
+	if (!endWord && !separatorIsRequired)
 		endWord = word + strlen(word);
 	// Last case always succeeds so endWord != 0
 
@@ -222,16 +236,16 @@ static size_t LengthWord(const char *word, char otherSeparator) {
 }
 
 template<typename Compare>
-static std::string GetMatches(std::vector<char *>::iterator start, std::vector<char *>::iterator end, const char *wordStart, char otherSeparator, bool exactLen, Compare comp) {
+static std::string GetMatches(std::vector<char *>::iterator start, std::vector<char *>::iterator end, const char *wordStart, const char* otherSeparators, bool exactLen, Compare comp, bool separatorIsRequired = false) {
 	std::string wordList;
-	const size_t wordStartLength = LengthWord(wordStart, otherSeparator);
+	const size_t wordStartLength = LengthWord(wordStart, otherSeparators);
 	std::vector<char *>::iterator elem = std::lower_bound(start, end, wordStart, comp);
 	// Found a matching element, now accumulate all matches
 	for (; elem < end; ++elem) {
 		if (comp(wordStart, *elem) || comp(*elem, wordStart))
 			break;	// Not a match so stop
 		// length of the word part (before the '(' brace) of the api array element
-		const size_t wordlen = LengthWord(*elem, otherSeparator);
+		const size_t wordlen = LengthWord(*elem, otherSeparators, separatorIsRequired);
 		if (!exactLen || (wordlen == wordStartLength)) {
 			if (wordList.length() > 0)
 				wordList.append(" ", 1);
@@ -253,16 +267,17 @@ std::string StringList::GetNearestWords(
     const char *wordStart,
     size_t searchLen,
     bool ignoreCase,
-    char otherSeparator /*= '\0'*/,
-    bool exactLen /*=false*/) {
+    const char* otherSeparators /*= '\0'*/,
+    bool exactLen /*=false*/,
+	bool separatorIsRequired /*=false*/) {
 
 	if (words.empty())
 		return std::string();
 	SortIfNeeded(ignoreCase);
 	if (ignoreCase) {
-		return GetMatches(wordsNoCase.begin(), wordsNoCase.end(), wordStart, otherSeparator, exactLen, CompareStringInsensitive(searchLen));
+		return GetMatches(wordsNoCase.begin(), wordsNoCase.end(), wordStart, otherSeparators, exactLen, CompareStringInsensitive(searchLen), separatorIsRequired);
 	} else {
 		// Preserve the letter case
-		return GetMatches(words.begin(), words.end(), wordStart, otherSeparator, exactLen, CompareString(searchLen));
+		return GetMatches(words.begin(), words.end(), wordStart, otherSeparators, exactLen, CompareString(searchLen), separatorIsRequired);
 	}
 }
diff --git a/scite/src/StringList.h b/scite/src/StringList.h
index 447f459..a6f5d70 100644
--- a/scite/src/StringList.h
+++ b/scite/src/StringList.h
@@ -28,7 +28,9 @@ public:
 	void Set(const char *s);
 	void Set(const std::vector<char> &data);
 	std::string GetNearestWord(const char *wordStart, size_t searchLen,
-		bool ignoreCase, const std::string &wordCharacters, int wordIndex);
+		bool ignoreCase, const std::string &wordCharacters, int wordIndex = -1,
+		bool skipBareWords = false);
 	std::string GetNearestWords(const char *wordStart, size_t searchLen,
-		bool ignoreCase, char otherSeparator='\0', bool exactLen=false);
+		bool ignoreCase, const char* otherSeparators=NULL, bool exactLen=false,
+		bool separatorIsRequired=false);
 };
diff --git a/scite/win32/MessagePump.cxx b/scite/win32/MessagePump.cxx
new file mode 100644
index 0000000..a415252
--- /dev/null
+++ b/scite/win32/MessagePump.cxx
@@ -0,0 +1,166 @@
+// SciTE4AutoHotkey v3 Lua message pumper
+
+// Includes
+#include <windows.h>
+#include <tchar.h>
+extern "C"
+{
+#include "lauxlib.h"
+}
+
+// Some defines
+#define RET_OK 1
+#define RET_FAIL 0
+#define MAX_TITLE 255
+
+// Global variables
+static HWND cWindow = 0, tWindow = 0;
+static const char* cWinTitle; // variable pointer to constant char
+
+// Private callback function to enumerate the windows.
+static BOOL CALLBACK _lib_winsearchproc(HWND hWnd, LPARAM lParam)
+{
+	char wTitle[MAX_TITLE+1];
+	// Get window title
+	GetWindowTextA(hWnd, wTitle, MAX_TITLE);
+	if (strncmp(wTitle, cWinTitle, lParam) == 0)
+	{
+		// Window found.
+		cWindow = hWnd;
+		return 0; // Cancel the enumeration
+	}
+	return 1; // Continue enumerating the windows
+}
+
+// localizewin(wintitle) -- Localizes the window with the specified window title to
+//  further send messages to it. True = sucess, false = failure.
+static int lib_localizewin(lua_State* L)
+{
+	// set the global variables
+	cWinTitle = luaL_checkstring(L, 1);
+	tWindow = cWindow, cWindow = 0;
+
+	// look for the window
+	EnumWindows((WNDENUMPROC)_lib_winsearchproc, strlen(cWinTitle));
+	if (!cWindow) // no window found?
+	{
+		// just restore the old window and return false.
+		cWindow = tWindow;
+		lua_pushboolean(L, RET_FAIL);
+		return 1;
+	}
+	// return true.
+	lua_pushboolean(L, RET_OK);
+	return 1;
+}
+
+// pumpmsg(msg, wParam, lParam) -- Sends a message to the current window.
+static int lib_pumpmsg(lua_State* L)
+{
+	int result;
+
+	// get the parameters
+	int iMsg = luaL_checkint(L, 1);
+	int wParam = luaL_checkint(L, 2);
+	int lParam = luaL_checkint(L, 3);
+
+	if (!IsWindow(cWindow)) // invalid window?
+		return luaL_error(L, "Invalid window handle.");
+
+	// just dispatch the message to the window
+	result = (int) SendMessageA(cWindow, (UINT)iMsg, (WPARAM)wParam, (LPARAM)lParam);
+	
+	// return the number that the window gave to us
+	lua_pushinteger(L, result);
+	return 1;
+}
+
+// postmsg(msg, wParam, lParam) -- Posts a message to the current window.
+static int lib_postmsg(lua_State* L)
+{
+	int result;
+
+	// get the parameters
+	int iMsg = luaL_checkint(L, 1);
+	int wParam = luaL_checkint(L, 2);
+	int lParam = luaL_checkint(L, 3);
+
+	if (!IsWindow(cWindow)) // invalid window?
+		return luaL_error(L, "Invalid window handle.");
+
+	// just dispatch the message to the window
+	result = PostMessageA(cWindow, (UINT)iMsg, (WPARAM)wParam, (LPARAM)lParam);
+	
+	// return the return code
+	lua_pushboolean(L, result);
+	return 1;
+}
+
+// pumpmsg(msg, wparam, lparam) -- Sends a message in which lParam will be received as a string.
+static int lib_pumpmsgstr(lua_State* L)
+{
+	DWORD pID;
+	HANDLE hProcess;
+	void* rlParam;
+	int result;
+
+	// get the parameters
+	int iMsg = luaL_checkint(L, 1);
+	int wParam = luaL_checkint(L, 2);
+	const char* lParam = luaL_checkstring(L, 3);
+	// get the string length
+	size_t lParamSize = strlen(lParam) + 1;
+
+	if (!IsWindow(cWindow)) // invalid window?
+		return luaL_error(L, "Invalid window handle.");
+
+	// inject the string at the process.
+	GetWindowThreadProcessId(cWindow, &pID);
+	hProcess = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE, 0, pID);
+	if (!hProcess)
+		return luaL_error(L, "Couldn't open the memory of the window!");
+	rlParam = VirtualAllocEx(hProcess, 0, lParamSize, MEM_COMMIT, PAGE_READWRITE);
+	if (!rlParam)
+		return luaL_error(L, "Couldn't allocate the memory at the window!");
+	if (!WriteProcessMemory(hProcess, rlParam, lParam, lParamSize, NULL))
+		return luaL_error(L, "Couldn't inject the string parameter at the window!");
+
+	// just dispatch the message to the window
+	result = (int) SendMessageA(cWindow, (UINT)iMsg, (WPARAM)wParam, (LPARAM)rlParam);
+
+	// free the memory used by the string
+	if (!VirtualFreeEx(hProcess, rlParam, 0, MEM_RELEASE))
+		return luaL_error(L, "Failed to free the memory at the window!");
+	if (!CloseHandle(hProcess))
+		return luaL_error(L, "Couldn't close the process handle!");
+
+	// return the number that the window gave to us
+	lua_pushinteger(L, result);
+	return 1;
+}
+
+// sleep(time) -- sleeps for the specified amount of time
+static int lib_sleep(lua_State* L)
+{
+	Sleep(luaL_checkint(L, 1));
+	return 0;
+}
+
+static const luaL_Reg pumpLib[] =
+{
+	{ "localizewin", lib_localizewin },
+	{ "pumpmsg", lib_pumpmsg },
+	{ "pumpmsgstr", lib_pumpmsgstr },
+	{ "postmsg", lib_postmsg },
+	{ "sleep", lib_sleep },
+	{ NULL, NULL }
+};
+
+int MessagePumpLibInit(lua_State* L)
+{
+	// register the library's functions in the Lua engine
+	for (const luaL_Reg* it = pumpLib; it->name; it ++)
+		lua_register(L, it->name, it->func);
+
+	return 0;
+}
diff --git a/scite/win32/SciTERes.rc b/scite/win32/SciTERes.rc
index 666ef83..c65f45e 100644
--- a/scite/win32/SciTERes.rc
+++ b/scite/win32/SciTERes.rc
@@ -6,7 +6,9 @@
 
 #include "SciTE.h"
 
-SciTE ICON SciBall.ico
+// fincs-edit
+//SciTE ICON SciBall.ico
+IDI_MAINICON ICON SciBall.ico
 
 1 RT_MANIFEST SciTE.exe.manifest
 
@@ -179,24 +181,24 @@ END
 POPUP "&Help"
 BEGIN
 	MENUITEM "&Help\tF1", 				IDM_HELP
+	MENUITEM "&SciTE4AutoHotkey Help",		IDM_HELP_SCITE
 #ifdef STATIC_BUILD
-	MENUITEM "&Sc1 Help",			IDM_HELP_SCITE
-	MENUITEM "&About Sc1",				IDM_ABOUT
+	MENUITEM "&About SciTE4AutoHotkey Lite",	IDM_ABOUT
 #else
-	MENUITEM "&SciTE Help",			IDM_HELP_SCITE
-	MENUITEM "&About SciTE",			IDM_ABOUT
+	MENUITEM "&About SciTE4AutoHotkey",		IDM_ABOUT
 #endif
 END
 
 END
 
 ABOUT DIALOGEX 26, 41, 350, 242
-CAPTION "About SciTE"
+CAPTION "About SciTE4AutoHotkey"
 STYLE DS_MODALFRAME | DS_3DLOOK | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
 FONT 8, "MS Shell Dlg"
 BEGIN
 	CONTROL "", IDABOUTSCINTILLA, "Scintilla", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 1, 1, 346, 218
-	ICON "SciTE", -1, 1, 221, 32, 32, WS_CHILD | WS_VISIBLE
+	//ICON "SciTE", -1, 1, 221, 32, 32, WS_CHILD | WS_VISIBLE
+	ICON IDI_MAINICON, -1, 1, 221, 32, 32, WS_CHILD | WS_VISIBLE // fincs-edit
 	DEFPUSHBUTTON "OK", IDOK, 26, 222, 322, 20, WS_TABSTOP
 END
 
@@ -565,6 +567,7 @@ BEGIN
 END
 
 IDR_CLOSEFILE BITMAP "closefile.bmp"
+IDR_CLOSEFILE_BIG BITMAP "closefile_big.bmp"
 
 IDBM_WORD BITMAP "word.bmp"
 IDBM_CASE BITMAP "case.bmp"
@@ -617,13 +620,13 @@ BEGIN
 	BEGIN
 		BLOCK "040904b0"
 		BEGIN
-			VALUE	"CompanyName",	"Neil Hodgson neilh@scintilla.org\0"
-			VALUE	"FileDescription",	"SciTE - a Scintilla based Text Editor\0"
+			VALUE	"CompanyName",	"fincs - Original SciTE by Neil Hodgson: neilh@scintilla.org\0"
+			VALUE	"FileDescription",	"SciTE4AutoHotkey - a SciTE distribution for AutoHotkey\0"
 			VALUE	"FileVersion",	VERSION_SCITE "\0"
-			VALUE	"InternalName",	"SciTE\0"
-			VALUE	"LegalCopyright",	"Copyright " COPYRIGHT_YEARS " by Neil Hodgson\0"
-			VALUE	"OriginalFilename",	"SciTE.EXE\0"
-			VALUE	"ProductName",	"SciTE\0"
+			VALUE	"InternalName",	"SciTE4AutoHotkey\0"
+			VALUE	"LegalCopyright",	"SciTE is (c) " COPYRIGHT_YEARS " Neil Hodgson, SciTE4AutoHotkey is (c) " COPYRIGHT_YEARS_S4AHK " by fincs\0"
+			VALUE	"OriginalFilename",	"SciTE.exe\0"
+			VALUE	"ProductName",	"SciTE4AutoHotkey\0"
 			VALUE	"ProductVersion",	VERSION_SCITE "\0"
 		END
 	END
